<template>
  <h1 v-if="!edit && !loading" :class="['Title', props.class]">
    {{ value }}
  </h1>

  <PSkeleton
    v-if="loading"
    height="2rem"
    :class="['Title', 'Title__Skeleton', props.class]"
  />

  <div v-if="edit && !loading">
    <label>
      <span class="Title__Label">{{ props.label }}</span>
      <PInputText
        v-model="value"
        class="Title__Input"
        type="text"
        maxlength="255"
        :placeholder="props.label"
      />
    </label>
    <ErrorWrapper :errors="props.errors" />
  </div>
</template>

<script lang="ts" setup>
import { computed } from 'vue'
import { FieldErrors } from '@/components/form/validation'

const props = withDefaults(
  defineProps<{
    label: string
    class?: string
    modelValue: string
    edit?: boolean
    loading?: boolean
    errors?: FieldErrors
  }>(),
  {
    class: '',
    modelValue: '',
    edit: false,
    loading: false,
    errors: () => [],
  }
)

const emit = defineEmits<{
  (e: 'update:modelValue', value: string): void
}>()

const value = computed({
  get: () => props.modelValue,
  set: (value: string) => emit('update:modelValue', value),
})
</script>
<style lang="scss" scoped>
@use 'src/style/variables' as v;

.Title {
  &__Skeleton {
    // Use same margin as a default <h1> tag
    margin: v.$spacing 0;
  }

  &__Label {
    position: relative;
    left: 8px;
    color: var(--secondary-color);
    font-size: 0.8em;
    line-height: 0.8em;
  }

  &__Input {
    display: block;
  }
}
</style>
